package xyz.tbvns.Models;

import com.badlogic.gdx.graphics.g3d.Model;
import imgui.ImGui;
import lombok.Data;
import xyz.tbvns.Editor.ModelsManager;
import xyz.tbvns.ui.Renderable;

import java.util.ArrayList;
import java.util.List;

@Data
public class Animation implements Renderable {
    private List<GDModel> frames = new ArrayList<>();
    private List<Model> modelFrames = new ArrayList<>();
    private String name;

    public void generate() {
        for (GDModel frame : frames) {
            modelFrames.add(frame.toModel());
        }
    }

    public void dispose() {
        for (Model modelFrame : modelFrames) {
            modelFrame.dispose();
        }
    }

    @Override
    public void render() {
        ImGui.separator();
        ImGui.text(name);
        ImGui.text("Frames:" + frames.size());
        if (ImGui.button("Add " + name)) {
            ModelsManager.addAnimation(this);
        }
    }
}
